<template>
  <div>
    <div class="gva-search-box">
      <el-form :inline="true" :model="searchInfo" class="demo-form-inline" @keyup.enter="onSubmit">
      <el-form-item label="创建时间">
      <el-date-picker v-model="searchInfo.startCreatedAt" type="datetime" placeholder="开始时间"></el-date-picker>
       —
      <el-date-picker v-model="searchInfo.endCreatedAt" type="datetime" placeholder="结束时间"></el-date-picker>
      </el-form-item>
      <el-form-item label="红包编号:" >
        <el-input v-model="searchInfo.ID"  placeholder="请输入红包编号" />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="search" @click="onSubmit">查询</el-button>
        <el-button icon="refresh" @click="onReset">重置</el-button>
      </el-form-item>
      </el-form>
    </div>
    <div class="gva-table-box">
      <div class = "message-container"><span :balance="balance">红包出币余额:{{balance}}BTY</span></div>
        <div class="gva-btn-list">
            <el-button type="primary" icon="plus" @click="openDialog">新增</el-button>
            <el-popover v-model:visible="deleteVisible" placement="top" width="160">
            <p>确定要删除吗？</p>
            <div style="text-align: right; margin-top: 8px;">
                <el-button type="primary" link @click="deleteVisible = false">取消</el-button>
                <el-button type="primary" @click="onDelete">确定</el-button>
            </div>
            <template #reference>
                <el-button icon="delete" style="margin-left: 10px;" :disabled="!multipleSelection.length" @click="deleteVisible = true">删除</el-button>
            </template>
            </el-popover>
        </div>
        <el-table
        ref="multipleTable"
        style="width: 100%"
        tooltip-effect="dark"
        :data="tableData"
        row-key="ID"
        @sort-change="sortChange"
        @selection-change="handleSelectionChange"
        >
        <el-table-column type="selection" width="55" />
        <el-table-column align="left" label="红包编号" prop="ID" width="120" sortable="custom">
          <template #default="scope">{{ scope.row.ID }}</template>
        </el-table-column>
        <el-table-column align="left" label="日期" width="180" sortable="custom">
            <template #default="scope">{{ formatDate(scope.row.CreatedAt) }}</template>
        </el-table-column>
        <el-table-column align="left" label="红包名称" prop="balance" width="120">
          <template #default="scope">{{ scope.row.name }}</template>
        </el-table-column>
        <el-table-column align="left" label="红包描述" prop="balance" width="120">
          <template #default="scope">{{ scope.row.desc }}</template>
        </el-table-column>
        <el-table-column align="left" label="红包总额" prop="balance" width="120">
            <template #default="scope">{{ scope.row.balance }}</template>
        </el-table-column>
        <el-table-column align="left" label="是否随机" prop="type" width="120">
            <template #default="scope">{{ formatBoolean(scope.row.type) }}</template>
        </el-table-column>
        <el-table-column align="left" label="红包个数" prop="num" width="120">
            <template #default="scope">{{ scope.row.num }}</template>
        </el-table-column>
        <el-table-column align="left" label="剩余个数" prop="num" width="60">
          <template #default="scope">{{ scope.row.remain_num }}</template>
        </el-table-column>
        <el-table-column align="left" label="ipLimit字段" prop="ipLimit" width="120">
            <template #default="scope">{{ scope.row.ip_limit }}</template>
        </el-table-column>
        <el-table-column align="left" label="是否显示" prop="isShow" width="120">
            <template #default="scope">{{ formatBoolean(scope.row.is_show) }}</template>
        </el-table-column>
          <el-table-column align="left" label="验证方式" prop="verify_type" width="120">
            <template #default="scope">{{ formatVerifyType(scope.row.verify_type) }}</template>
          </el-table-column>
          <el-table-column align="left" label="开启黑名单" prop="isShow" width="120">
            <template #default="scope">{{ formatBoolean(scope.row.is_black) }}</template>
          </el-table-column>
          <el-table-column align="left" label="口令" prop="is_password" width="120">
            <template #default="scope">{{ formatBoolean(scope.row.is_password) }}</template>
          </el-table-column>
         <el-table-column align="left" label="开始日期" width="180">
            <template #default="scope">{{ formatDate(scope.row.start_at) }}</template>
         </el-table-column>
         <el-table-column align="left" label="结束日期" width="180">
            <template #default="scope">{{ formatDate(scope.row.end_at) }}</template>
         </el-table-column>
<!--          <el-table-column align="left" label="白名单" width="180">-->
<!--            <template #default="scope">{{ scope.row.white }}</template>-->
<!--          </el-table-column>-->
        <el-table-column align="left" label="按钮组">
            <template #default="scope">
            <el-button type="primary" link icon="edit" class="table-button" @click="updateRedPackageFunc(scope.row)">变更</el-button>
            <el-button type="primary" link icon="delete" @click="deleteRow(scope.row)">删除</el-button>
<!--            <el-button type="primary" link icon="person" @click="whiteRowFunc(scope.row)">白名单</el-button>-->
            </template>
        </el-table-column>
        </el-table>
        <div class="gva-pagination">
            <el-pagination
            layout="total, sizes, prev, pager, next, jumper"
            :current-page="page"
            :page-size="pageSize"
            :page-sizes="[10, 30, 50, 100]"
            :total="total"
            @current-change="handleCurrentChange"
            @size-change="handleSizeChange"
            />
        </div>
    </div>
    <el-dialog v-model="dialogFormVisible" :before-close="closeDialog" title="弹窗操作">
      <el-form :model="formData" label-position="right" ref="elFormRef" :rules="rule" label-width="120px">
        <el-form-item label="红包名称:" prop="balance">
          <el-input v-model="formData.name" />
        </el-form-item>
        <el-form-item label="红包描述:" prop="balance">
          <el-input v-model="formData.desc" />
        </el-form-item>
        <el-form-item label="红包总金额"  prop="balance" >
          <el-input v-model.number="formData.balance" :clearable="true" placeholder="请输入" />
        </el-form-item>
        <el-form-item label="是否随机"  prop="type" >
          <el-switch v-model="formData.type" active-color="#13ce66" inactive-color="#ff4949" active-text="是" inactive-text="否" clearable ></el-switch>
        </el-form-item>
        <el-form-item label="红包个数:"  prop="num" >
          <el-input v-model.number="formData.num" :clearable="true" placeholder="请输入" />
        </el-form-item>
        <el-form-item label="ip限制个数:"  prop="ipLimit" >
          <el-input v-model.number="formData.ip_limit" :clearable="true" placeholder="请输入" />
        </el-form-item>
        <el-form-item label="是否显示:"  prop="isShow" >
          <el-switch v-model="formData.is_show" active-color="#13ce66" inactive-color="#ff4949" active-text="是" inactive-text="否" clearable ></el-switch>
        </el-form-item>
        <el-form-item label="开启黑名单:"  prop="isBlack" >
          <el-switch v-model="formData.is_black" active-color="#13ce66" inactive-color="#ff4949" active-text="是" inactive-text="否" clearable ></el-switch>
        </el-form-item>
        <el-form-item label="开始时间:"  prop="startAt" >
          <el-date-picker v-model="formData.start_at" type="datetime" style="width:100%" placeholder="选择日期" :clearable="true"  />
        </el-form-item>
        <el-form-item label="结束时间:"  prop="endAt" >
          <el-date-picker v-model="formData.end_at" type="datetime" style="width:100%" placeholder="选择日期" :clearable="true"  />
        </el-form-item>
        <el-form-item label="验证方式" style="width:30%">
          <el-select v-model="formData.verify_type" placeholder="选择验证方式">
            <el-option :value=0 label="Google验证" />
            <el-option :value=1 label="声纹验证" />
            <el-option :value=2 label="无验证" />
          </el-select>
        </el-form-item>
        <el-form-item label="ip白名单:" prop="ip_white">
          <el-input v-model="formData.ip_white" placeholder="多个ip 以,分割"/>
        </el-form-item>
        <el-form-item label="口令红包:"  prop="is_password" >
          <el-switch v-model="formData.is_password" active-color="#13ce66" inactive-color="#ff4949" active-text="是" inactive-text="否" clearable ></el-switch>
        </el-form-item>
        <el-form-item label="口令:"  prop="password" >
          <el-input v-model="formData.password" :clearable="true" placeholder="请输入口令" />
        </el-form-item>
        <el-form-item label="白名单:"  prop="white" >
          <el-input v-model="formData.white" type="textarea" placeholder="请输入白名单地址 以,分割" />
          <div v-loading.fullscreen.lock="fullscreenLoading">

            <el-upload
                ref="upload"
                :action="`${path}/redPackage/convertWhiteList`"
                :before-upload="checkFile"
                :headers="{ 'x-token': userStore.token }"
                :on-error="uploadError"
                :on-success="uploadSuccess"
                :show-file-list="false"
                class="upload-btn"
            >
              <el-button type="primary">普通上传</el-button>
            </el-upload>
          </div>
        </el-form-item>
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button @click="closeDialog">取 消</el-button>
          <el-button type="primary" @click="enterDialog">确 定</el-button>
        </div>
      </template>
    </el-dialog>
    <el-dialog v-model="dialogFormVisibleTwo" :before-close="closeDialogTwo" title="弹窗操作2">
      <el-form :model="formData" label-position="right" ref="elFormRef" :rules="rule" label-width="120px">
        <el-form-item label="红包名称:" prop="balance">
          <el-input v-model="formData.name" />
        </el-form-item>
        <el-form-item label="红包描述:" prop="balance">
          <el-input v-model="formData.desc" />
        </el-form-item>
        <el-form-item label="红包总金额"  prop="balance" >
          <el-input v-model.number="formData.balance"  placeholder="请输入" readonly="readonly"/>
        </el-form-item>
        <el-form-item label="是否随机"  prop="type" >
          <el-switch v-model="formData.type" active-color="#13ce66" inactive-color="#ff4949" active-text="是" inactive-text="否" clearable readonly="readonly"></el-switch>
        </el-form-item>
        <el-form-item label="红包个数:"  prop="num" >
          <el-input v-model.number="formData.num" :clearable="true" placeholder="请输入" readonly="readonly"/>
        </el-form-item>
        <el-form-item label="剩余个数:"  prop="remain_num" >
          <el-input v-model.number="formData.remain_num" :clearable="true" placeholder="请输入" readonly="readonly"/>
        </el-form-item>
        <el-form-item label="ip限制个数:"  prop="ipLimit" >
          <el-input v-model.number="formData.ip_limit" :clearable="true" placeholder="请输入" />
        </el-form-item>
        <el-form-item label="是否显示:"  prop="isShow" >
          <el-switch v-model="formData.is_show" active-color="#13ce66" inactive-color="#ff4949" active-text="是" inactive-text="否" clearable ></el-switch>
        </el-form-item>
        <el-form-item label="开启黑名单:"  prop="isBlack" >
          <el-switch v-model="formData.is_black" active-color="#13ce66" inactive-color="#ff4949" active-text="是" inactive-text="否" clearable ></el-switch>
        </el-form-item>
        <el-form-item label="开始时间:"  prop="startAt" >
          <el-date-picker v-model="formData.start_at" type="datetime" style="width:100%" placeholder="选择日期" :clearable="true"  />
        </el-form-item>
        <el-form-item label="结束时间:"  prop="endAt" >
          <el-date-picker v-model="formData.end_at" type="datetime" style="width:100%" placeholder="选择日期" :clearable="true"  />
        </el-form-item>
        <el-form-item label="白名单:"  prop="white" >
          <el-input v-model="formData.white" :clearable="true" type="textarea" placeholder="请输入白名单地址，以,分隔" />
        </el-form-item>
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button @click="closeDialogTwo">取 消</el-button>
          <el-button type="primary" @click="enterDialogTwo">确 定</el-button>
        </div>
      </template>
    </el-dialog>
    <el-dialog v-model="dialogFormVisibleThree" :before-close="closeDialogThree" title="白名单">
      <el-table
          ref="multipleTableWhite"
          style="width: 100%"
          tooltip-effect="dark"
          :data="tableWhiteData"
          row-key="ID"
          @selection-change="handleSelectionChange"
      >
        <el-table-column type="selection" width="55" />
        <el-table-column align="left" label="地址" width="180">
          <template #default="scope">{{ (scope.row) }}</template>
        </el-table-column>

        <el-table-column align="left" label="按钮组">
          <template #default="scope">
            <el-button type="primary" link icon="edit" class="table-button" @click="updateRedPackageFunc(scope.row)">变更</el-button>
            <el-button type="primary" link icon="delete" @click="deleteRow(scope.row)">删除</el-button>
            <!--            <el-button type="primary" link icon="person" @click="whiteRowFunc(scope.row)">白名单</el-button>-->
          </template>
        </el-table-column>
      </el-table>
    </el-dialog>

  </div>
</template>

<script>
export default {
  name: 'RedPackage'
}
</script>

<script setup>
import {
  createRedPackage,
  deleteRedPackage,
  deleteRedPackageByIds,
  updateRedPackage,
  findRedPackage,
  getRedPackageList,
  getRedPackageWhiteList,
    queryBalance
} from '@/api/redPackage'

// 全量引入格式化工具 请按需保留
import { toSQLLine } from '@/utils/stringFun'
import { getDictFunc, formatDate, formatBoolean, filterDict,formatVerifyType } from '@/utils/format'
import { ElMessage, ElMessageBox } from 'element-plus'
import { ref, reactive } from 'vue'
import { useUserStore } from '@/pinia/modules/user'

// 自动化生成的字典（可能为空）以及字段
const formData = ref({
        balance: 0,
        type: false,
        num: 0,
        remain_num: 0,
        ip_limit: 0,
        is_show: false,
        start_at: new Date(),
        end_at: new Date(),
        name: '',
        desc: '',
        white: '',
        verify_type: 0,
        is_password: false,
        password: ''
        })

// 验证规则
const rule = reactive({
               balance : [{
                   required: true,
                   message: '',
                   trigger: ['input','blur'],
               }],
               num : [{
                   required: true,
                   message: '',
                   trigger: ['input','blur'],
               }],
               ip_limit : [{
                   required: true,
                   message: '',
                   trigger: ['input','blur'],
               }],
})

const elFormRef = ref()


// =========== 表格控制部分 ===========
const page = ref(1)
const total = ref(0)
const pageSize = ref(10)
const tableData = ref([])
const searchInfo = ref({})
const tableWhiteData = ref([])
const balance = ref(0)

// 重置
const onReset = () => {
  searchInfo.value = {}
  getTableData()
}

// 搜索
const onSubmit = () => {
  page.value = 1
  pageSize.value = 10
  if (searchInfo.value.type === ""){
      searchInfo.value.type=null
  }
  if (searchInfo.value.isShow === ""){
      searchInfo.value.isShow=null
  }
  getTableData()
}

// 分页
const handleSizeChange = (val) => {
  pageSize.value = val
  getTableData()
}

// 修改页面容量
const handleCurrentChange = (val) => {
  page.value = val
  getTableData()
}

// 查询
const getTableData = async() => {
  const table = await getRedPackageList({ page: page.value, pageSize: pageSize.value, ...searchInfo.value })
  if (table.code === 0) {
    tableData.value = table.data.list
    total.value = table.data.total
    page.value = table.data.page
    pageSize.value = table.data.pageSize
  }
  const accBalance = await queryBalance()
  if (accBalance.code === 0) {
    console.log(accBalance.data)
    balance.value = accBalance.data
  }
}

getTableData()

// ============== 表格控制部分结束 ===============

// 获取需要的字典 可能为空 按需保留
const setOptions = async () =>{
}

// 获取需要的字典 可能为空 按需保留
setOptions()

// 排序
const sortChange = ({ prop, order }) => {
  if (prop) {
    if (prop === 'ID') {
      prop = 'id'
    }
    searchInfo.value.orderKey = toSQLLine(prop)
    searchInfo.value.desc = order === 'descending'
  }
  getTableData()
}

// 多选数据
const multipleSelection = ref([])
// 多选
const handleSelectionChange = (val) => {
    multipleSelection.value = val
}

// 删除行
const deleteRow = (row) => {
    ElMessageBox.confirm('确定要删除吗?', '提示', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning'
    }).then(() => {
            deleteRedPackageFunc(row)
        })
    }


// 批量删除控制标记
const deleteVisible = ref(false)

// 多选删除
const onDelete = async() => {
      const ids = []
      if (multipleSelection.value.length === 0) {
        ElMessage({
          type: 'warning',
          message: '请选择要删除的数据'
        })
        return
      }
      multipleSelection.value &&
        multipleSelection.value.map(item => {
          ids.push(item.ID)
        })
      const res = await deleteRedPackageByIds({ ids })
      if (res.code === 0) {
        ElMessage({
          type: 'success',
          message: '删除成功'
        })
        if (tableData.value.length === ids.length && page.value > 1) {
          page.value--
        }
        deleteVisible.value = false
        getTableData()
      }
    }

// 行为控制标记（弹窗内部需要增还是改）
const type = ref('')

// 更新行
const updateRedPackageFunc = async(row) => {
    const res = await findRedPackage({ ID: row.ID })
    type.value = 'update'
    if (res.code === 0) {
        formData.value = res.data.redPackage
        dialogFormVisibleTwo.value = true
    }
}

// 更新行
const whiteRowFunc = async(row) => {
  const res = await getWhiteList({ ID: row.ID })
  //type.value = 'update'
  if (res.code === 0) {
    formData.value = res.data.redPackage
    dialogFormVisibleThree.value = true
  }
}

// 删除行
const deleteRedPackageFunc = async (row) => {
    const res = await deleteRedPackage({ ID: row.ID })
    if (res.code === 0) {
        ElMessage({
                type: 'success',
                message: '删除成功'
            })
            if (tableData.value.length === 1 && page.value > 1) {
            page.value--
        }
        getTableData()
    }
}

// 弹窗控制标记
const dialogFormVisible = ref(false)
const dialogFormVisibleTwo = ref(false)
const dialogFormVisibleThree = ref(false)

// 打开弹窗
const openDialog = () => {
    type.value = 'create'
    dialogFormVisible.value = true
}

// 关闭弹窗
const closeDialog = () => {
    dialogFormVisible.value = false
    formData.value = {
          balance: 0,
          type: false,
          num: 0,
          remain_num: 0,
          ip_limit: 0,
          is_show: false,
          start_at: new Date(),
          end_at: new Date(),
          name: '',
          desc: '',
          white: '',
        }
}

// 关闭弹窗
const closeDialogTwo = () => {
  dialogFormVisibleTwo.value = false
    formData.value = {
      balance: 0,
      type: false,
      num: 0,
      remain_num: 0,
      ip_limit: 0,
      is_show: false,
      start_at: new Date(),
      end_at: new Date(),
      name: '',
      desc: '',
      whitte: '',
    }
}

// 关闭弹窗
const closeDialogThree = () => {
  dialogFormVisibleTwo.value = false
}

// 弹窗确定
const enterDialog = async () => {
     elFormRef.value?.validate( async (valid) => {
             if (!valid) return
              let res
              switch (type.value) {
                case 'create':
                  res = await createRedPackage(formData.value)
                  break
                case 'update':
                  res = await updateRedPackage(formData.value)
                  break
                default:
                  res = await createRedPackage(formData.value)
                  break
              }
              if (res.code === 0) {
                ElMessage({
                  type: 'success',
                  message: '创建/更改成功'
                })
                closeDialog()
                getTableData()
              }
      })
}
// 弹窗确定
const enterDialogTwo = async () => {
  elFormRef.value?.validate( async (valid) => {
    if (!valid) return
    let res
    switch (type.value) {
      case 'create':
        res = await createRedPackage(formData.value)
        break
      case 'update':
        res = await updateRedPackage(formData.value)
        break
      default:
        res = await createRedPackage(formData.value)
        break
    }
    if (res.code === 0) {
      ElMessage({
        type: 'success',
        message: '创建/更改成功'
      })
      closeDialogTwo()
      getTableData()
    }
  })
}

const emit = defineEmits(['on-success'])
const userStore = useUserStore()
const fullscreenLoading = ref(false)
const path = ref(import.meta.env.VITE_BASE_API)

const checkFile = (file) => {
  console.log("test")
  fullscreenLoading.value = true
  const isLt10M = file.size / 1024 / 1024 < 10
  if (!isLt10M) {
    ElMessage.error('文件不能超过 10m，请使用压缩上传')
    fullscreenLoading.value = false
  }
  return isLt10M
}

const uploadSuccess = (res,file,fileList) => {
  console.log(res);
  if (res.code == 0) {
    formData.value.white = res.data.list.join(",")
    console.log(formData)
    ElMessage({
      type: 'success',
      message: '上传成功'
    })
    fullscreenLoading.value = false
  } else {
    console.log("failed")
    ElMessage({
      type: 'error',
      message: res.msg
    })
    fullscreenLoading.value = false
  }
}

const uploadError = () => {
  ElMessage({
    type: 'error',
    message: '上传失败'
  })
  fullscreenLoading.value = false
}
</script>

<style>
.message-container {
  /* 添加一些样式使显示更优雅 */
  padding: 20px;
  border: 1px solid #ccc;
  border-radius: 5px;
  max-width: 400px;
  margin: 0 auto;
  text-align: center;
}
</style>
